import 'package:ble_connectivity/ble_connectivity_target_platform.dart';
import 'package:ble_connectivity/model/fhp_ble_device.dart';
import 'package:ble_connectivity/model/scan_properties.dart';
import 'package:ble_connectivity/sensor_abstraction_layer.dart';

class BleConnectivity {
  final BleConnectivityTargetPlatform platform;
  final SensorAbstractionLayer /*?*/ sensorLayer;

  BleConnectivity(this.sensorLayer)
      : platform = BleConnectivityTargetPlatform.instance {
    sensorLayer?.blePlatform = platform;
  }

  initScan(ScanProperties scanProperties) {
    platform.initScan(scanProperties);
  }

  disconnectWithSensor(FhpBleDevice device) {
    platform.disconnectWithSensor(device);
    sensorLayer.disconnectWithSensor(device);
  }
}
