import 'package:ble_connectivity/model/fhp_ble_charatereristic.dart';

const ACCELEROMETER_UNIT_FACTOR = (4 / 32768.0) * 9.81;

Map<String, List<FhpBleCharacteristic>> kIotipCharacteristics = {
  IotipService.battery.uuid: [
    FhpBleCharacteristic(
      uuid: IotipCharateristic.batteryLevel.uuid,
      receiveNotifications: true,
    ),
    FhpBleCharacteristic(
      uuid: IotipCharateristic.batteryChargeState.uuid,
      receiveNotifications: true,
    ),
  ],
  IotipService.accelerometer.uuid: [
    FhpBleCharacteristic(
      uuid: IotipCharateristic.accConfig.uuid,
      receiveNotifications: false,
      configValue: [0x81], //100Hz
    ),
    FhpBleCharacteristic(
      uuid: IotipCharateristic.accelerometer.uuid,
      receiveNotifications: true,
    ),
  ],
/*  IotipService.currentBattery.uuid: [
    FhpBleCharacteristic(
        uuid: IotipCharateristic.currentBatteryLevel.uuid,
        receiveNotifications: false),
  ],

 */
};

class IotipService {
  final String uuid;

  const IotipService._(this.uuid);

  @override
  String toString() {
    return uuid;
  }

  static const IotipService battery =
      IotipService._('0000180f-0000-1000-8000-00805f9b34fb');
  static const IotipService currentBattery = IotipService._('battery_service');
  static const IotipService accelerometer =
      IotipService._('00001020-702b-69b5-b243-d6094a2b0e24');
}

class IotipCharateristic {
  final String uuid;

  const IotipCharateristic._(this.uuid);

  @override
  String toString() {
    return uuid;
  }

  static const IotipCharateristic batteryLevel =
      IotipCharateristic._('00002a19-0000-1000-8000-00805f9b34fb');
  static const IotipCharateristic batteryChargeState =
      IotipCharateristic._('00002a1a-0000-1000-8000-00805f9b34fb');
  static const IotipCharateristic accelerometer =
      IotipCharateristic._('00001021-702b-69b5-b243-d6094a2b0e24');
  static const IotipCharateristic accConfig =
      IotipCharateristic._('00001022-702b-69b5-b243-d6094a2b0e24');
  static const IotipCharateristic currentBatteryLevel =
      IotipCharateristic._('battery_level');
}
