import 'package:flutter/foundation.dart';

class FhpBleCharacteristic {
  final String uuid;
  final List<int> configValue;
  final bool receiveNotifications;

  const FhpBleCharacteristic({
    @required this.uuid,
    this.configValue,
    @required this.receiveNotifications,
  });

  bool get hasConfiguration => configValue != null;

  Map<String, dynamic> toMap() {
    Map<String, dynamic> map = Map();

    map['uuid'] = this.uuid;
    map['configValue'] = this.configValue;
    map['receiveNotifications'] = this.receiveNotifications;
    return map;
  }

  @override
  String toString() {
    return '{"uuid": "${this.uuid}", "configValue": ${this.configValue}, "receiveNotifications": ${this.receiveNotifications}}';
  }
}
