//The used devices
let mSensors = new Map();


function onConnectionButtonClick(prefix, scanDuration, characteristics){
    var bleDevice = new BleDevice();
    if(bleDevice.connectionState == CONNECTION_STATE.DISCONNECTED){
        bleDevice.clickConnect(prefix, scanDuration, characteristics, (isConnected) => {

          if(isConnected){
            console.log('isConnected to '+bleDevice.bluetoothDevice.name + ', id=' +bleDevice.bluetoothDevice.id);
            mSensors.set(bleDevice.bluetoothDevice.name, bleDevice);
            DartOnSensorConnected(bleDevice.bluetoothDevice.name);

          }
          else {
            console.log('***onDisconnection***');
            onDisconnection(bleDevice);
          }

        }, (uuid, sensorEvent) => {
            onSensorEvent(bleDevice, uuid, sensorEvent);
        },
         (error) => {
            if(error == 'NotFoundError')
                DartStopScan();
            else
                callDartFunc();
        })

        .catch(function(error) {
            onDisconnection(bleDevice);
            console.log('Failed to connect: ' + error);
        });
    }
    else if(bleDevice.connectionState == CONNECTION_STATE.CONNECTED) {
        bleDevice.disconnect(bleDevice);
        onDisconnection(bleDevice);
    }
    else {
        window.alert("Already connecting!");
    }
}


function readCharacteristics(deviceName, characteristics){
    var device = mSensors.get(deviceName);
    device.readCharacteristics(characteristics);
}
function disconnectSensor(deviceName) {
    var device = mSensors.get(deviceName);
    device.disconnect();
}

function onCurrentDeviceValue(deviceName, service, characteristic) {
    var device = mSensors.get(deviceName);
    device.getCurrentValue(service, characteristic);
}

function onDisconnection(bleDevice){
    //DartOnSensorDisconnected(bleDevice.bluetoothDevice.name);

}

function onSensorEvent(bleDevice, uuid, sensorEvent){
    DartOnSensorEvent(bleDevice.bluetoothDevice.name, uuid, sensorEvent);
}


